<template>
	<div class="command">
		<SpinnerHolder class="loader" v-if="loading" :background="false"></SpinnerHolder>
		<CommonHeader :title="$t('command')"></CommonHeader>
		<div class="info">
			<p>{{ menuName }}</p>
		</div>
		<div class="items-container">
			<div class="item" v-for="(item, index) of order.items" :key="index">
				<div class="item-info">
					<Thumbnail class="thumbnail" :src="item.photoURL"></Thumbnail>
					<div>
						<span>{{ item.localizedName }}</span>
						<span class="small-details">{{ item.details }}</span><br>
						<span
							v-html="wantedIngredients.length ? reduceIngredients(wantedIngredients, $t('with')) : ''"
							class="small-details"
							:set="(wantedIngredients = item.ingredients.filter((i) => i.selected))"
						></span>
						<p>{{ formatPrice((item.price.ammount + item.priceIngredients) * item.quantity, true) }}</p>
					</div>
				</div>
				<div class="content-cantidades">
					<CounterButton
						class="counter"
						v-if="!orderSent"
						:toCero="true"
						@change="updateItemQuantity(index, item.quantity)"
						v-model="item.quantity"
					></CounterButton>
					<h2 class="number" v-else>{{ item.quanstity }}</h2>
				</div>
			</div>
		</div>
		<div class="send-container">
			<BeeInput
				class="send-button"
				:class="{ disabled: order.items.length == 0 }"
				@click="showFormOrContinueProcess()">
				<span>{{ $t('goPay') }}</span> <p>{{ `${$t('subtotal')} ${formatPrice(order.subtotal, true)} ` }}</p>
			</BeeInput>
		</div>
		<Modal v-if="modalForm" @close="hideForm()">
			<div v-if="!orderSent" class="send-form">
				<div class="form-group">
					<span class="label">{{ $t('name') }}:</span>
					<input
						name="fname"
						type="text"
						class="form-control bee-input"
						v-model.trim="formData.name"
						:placeholder="$t('johnDoe')"
					/>
					<span v-if="formErrors.name" class="error">{{ $t('nameError') }}</span>
				</div>
				<div class="form-group">
					<span class="label">{{ $t('place') }}:</span>
					<input
						name="fplace"
						type="text"
						class="form-control bee-input"
						v-model.trim="formData.place"
						:placeholder="$t('locationPlaceholder')"
					/>
					<span v-if="formErrors.place" class="error">{{ $t('placeError') }}</span>
				</div>
				<div class="form-group">
					<AjaxButton
						v-if="validatedCaptcha"
						class="final-button"
						:loading="loading"
						:text="$t('send')"
						@click="botValidation()"
					></AjaxButton>
					<span v-if="ajaxError" class="error">{{ $t('ajaxError') }}</span>
				</div>
				<div class="form-group" style="font-size: 10px">
					This site is protected by reCAPTCHA and the Google
					<a href="https://policies.google.com/privacy">Privacy Policy</a> and
					<a href="https://policies.google.com/terms">Terms of Service</a> apply.
				</div>
			</div>

			<div v-else class="good-ending" @click="$router.push('/menu')">
				<div class="title">
					<span>{{ $t('order') }}</span>
					<span>{{ readableId }}</span>
				</div>
				<VueQrcode :value="qrCodeContent" :options="{ width: 320 }"></VueQrcode>
				<BeeInput class="archive">{{ $t('archive') }}</BeeInput>
			</div>
		</Modal>

		<Modal v-if="modalFormDelivery" @close="hideFormDelivery()">
			<div v-if="!orderSent" class="send-form">
				<div class="form-group">
					<span class="label">{{ $t('name') }}:</span>
					<input
						name="fname"
						type="text"
						class="form-control bee-input"
						v-model.trim="formData.name"
						:placeholder="$t('johnDoe')"
					/>
					<span v-if="formErrorDelivery.name" class="error">{{ $t('nameError') }}</span>
				</div>
				<div class="form-group">
					<span class="label">{{ $t('correo') }}:</span>
					<input
						name="email"
						type="email"
						class="form-control bee-input"
						v-model.trim="formData.email"
						:placeholder="$t('correoPlaceholder')"
					/>
					<span v-if="formErrorDelivery.email" class="error">{{ $t('correoError') }}</span>
				</div>
				<div class="form-group">
					<span class="label">{{ $t('telephone') }}:</span>
					<input
						name="phone"
						type="text"
						class="form-control bee-input"
						v-model.trim="formData.phone"
						:placeholder="$t('telephonePlaceholder')"
					/>
					<span v-if="formErrorDelivery.phone" class="error">{{ $t('telephoneError') }}</span>
					<span v-if="formErrorDelivery.phoneRepeat" class="error">{{ $t('telephoneRepeatError') }}</span>
				</div>
				<div>
					<div>
						<input type="radio" :value="true" v-model="formData.terms" />
						<p class="terminos">He leido y acepto los <a href="#">terminos y condiciones</a></p>
						<p v-if="formErrorDelivery.terms" class="error">{{ $t('wrongTerm') }}</p>
					</div>
				</div>
				<div class="form-group">
					<AjaxButton
						v-if="validatedCaptcha"
						class="final-button"
						:loading="loading"
						:text="$t('continue')"
						@click="botValidation()"
					></AjaxButton>
					<span v-if="ajaxError" class="error">{{ $t('ajaxError') }}</span>
				</div>
				<div class="form-group" style="font-size: 10px">
					This site is protected by reCAPTCHA and the Google
					<a href="https://policies.google.com/privacy">Privacy Policy</a> and
					<a href="https://policies.google.com/terms">Terms of Service</a> apply.
				</div>
			</div>

			<div v-else class="good-ending" @click="$router.push('/menu')">
				<div class="title">
					<span>{{ $t('order') }}</span>
					<span>{{ readableId }}</span>
				</div>
				<VueQrcode :value="qrCodeContent" :options="{ width: 320 }"></VueQrcode>
				<BeeInput class="archive">{{ $t('archive') }}</BeeInput>
			</div>
		</Modal>
	</div>
</template>

<script lang="ts">
import { Component, Vue, Watch } from 'vue-property-decorator'
import CommonHeader from '@/components/CommonHeader.vue'
import Thumbnail from '@/components/Thumbnail.vue'
import BeeInput from '@/components/BeeInput.vue'
import AjaxButton from '@/components/AjaxButton.vue'
import CounterButton from '@/components/CounterButton.vue'
import Modal from '@/components/Modal.vue'
import Order, { StatusDelivery } from '../models/Order'
import { User } from '../models/User'
import OrderService from '@/services/OrderService'
import ItemIngredient from '../models/ItemIngredient'
import VueQrcode from '@chenfengyuan/vue-qrcode'
import { MainView, TypeOrder } from '@/store/state'
import axios from 'axios'
import SpinnerHolder from '@/components/SpinnerHolder.vue'

@Component({
	components: {
		CommonHeader,
		Thumbnail,
		CounterButton,
		BeeInput,
		Modal,
		AjaxButton,
		VueQrcode,
		SpinnerHolder,
	},
})
export default class Command extends Vue {
	menuName = this.$store.state.menu.name
	modalForm = false
	modalFormDelivery = false
	validatedCaptcha = true
	order: Order | null = this.$store.state.order
	thumbnailBorder = `border: 1px ${this.$store.getters.colors.backgroundColor} solid;`
	goodEnding = false
	loading = false
	ajaxError = false
	typeOrder = this.$store.state.typeOrder
	user: User | null = null
	acceptTerms = false
	formData = {
		name: '',
		place: '',
		phone: '',
		email: '',
		terms: false,
	}
	formErrors = {
		name: false,
		place: false,
	}
	formErrorDelivery = {
		name: false,
		phone: false,
		email: false,
		terms: false,
		phoneRepeat: false,
	}

	get qrCodeContent() {
		if (this.order) {
			let textOrder = `#${this.order.number} \n`
			textOrder += `${this.order.name} \n`
			if (this.typeOrder == TypeOrder.DELIVERY || this.typeOrder == TypeOrder.COLLECT) {
				textOrder += `${this.order.phone} \n`
				textOrder += `${this.order.email} \n`
			} else {
				textOrder += `${this.order.location} \n`
			}
			for (const item of this.order.items) {
				textOrder += `${item.name} X ${item.quantity} $ ${item.price} \n`
				const plus = item.ingredients.filter((i) => i.selected)
				if (plus.length) textOrder += this.reduceIngredients(plus, this.$t('with').toString()) + '\n'
				const minus = item.ingredients.filter((i) => !i.selected)
				if (minus.length) textOrder += this.reduceIngredients(plus, this.$t('without').toString()) + '\n'

				textOrder += '\n'
			}
			textOrder += `TOTAL: $${this.order.total} \n`
			return textOrder
		}
		return 'orden vacia'
	}

	get orderSent() {
		if (this.order && this.order.sent) return true
		return false
	}

	showFormOrContinueProcess() {
		const user = this.$store.state.user
		if (this.typeOrder == TypeOrder.DELIVERY || this.typeOrder == TypeOrder.COLLECT) {
			if (!user) {
				this.$router.push('/login')
			} else if (!this.checkDataUser()) {
				this.$router.push('/personalinfoedit')
			} else if (user && this.checkDataUser()) {
				if (this.$store.state.order.statusDelivery == StatusDelivery.ORDER) {
					if (this.typeOrder == TypeOrder.LOCAL && this.order) {
						this.modalForm = true
					} else if (
						this.typeOrder == TypeOrder.DELIVERY ||
						(this.typeOrder == TypeOrder.COLLECT && this.order)
					) {
						this.$router.push('/summary')
						// this.modalFormDelivery = true
					}
				} else if (this.$store.state.order.statusDelivery == StatusDelivery.FINISHED) {
					this.modalForm = true
				}else if(this.$store.state.order.statusDelivery == StatusDelivery.SUMMARY){
					this.$router.push('/summary')
				} 
			}
		}
	}

	get readableId() {
		if (this.order?.number) {
			return '#' + this.order.number
		}
		return ''
	}

	async botValidation() {
		let token = ''
		if (process.env.NODE_ENV == 'production') {
			await this.$recaptchaLoaded()
			token = await this.$recaptcha('sendOrder')
			try {
				const resp = await axios.post(`${process.env.VUE_APP_RECAPTCHA_VERIFIER}/api/v1/verify`, {
					token: token,
				})
				if (resp.data && resp.data.score < 0.5) {
					this.validatedCaptcha = false
					this.ajaxError = true
					return
				}
			} catch (err) {
				console.log(err)
			}
		}
		await this.sendForm(token)
	}

	async sendForm(token: string) {
		if (!this.order) return
		if (!this.validForm()) return

		this.loading = true

		if (this.user) this.order.userId = this.user.id

		this.order.name = this.formData.name
		this.order.number = OrderService.generateReadableId()
		this.order.status = 'PENDING'

		if (this.typeOrder == TypeOrder.DELIVERY || this.typeOrder == TypeOrder.COLLECT) {
			this.order.email = this.formData.email
			this.order.phone = this.formData.phone
			if (this.typeOrder == TypeOrder.DELIVERY) {
				this.order.type = TypeOrder.DELIVERY
				this.order.statusDelivery = StatusDelivery.SUMMARY
			} else if (this.typeOrder == TypeOrder.COLLECT) {
				this.order.type = TypeOrder.COLLECT
			}
		} else if (this.typeOrder == TypeOrder.LOCAL) {
			this.order.location = this.formData.place
			this.order.type = TypeOrder.LOCAL
		}

		this.$analytics.logEvent('begin_checkout', {
			value: this.order.subtotal + this.order.deliveryCost,
			currency: this.order.currency,
			items: this.order.items.map((item) => ({
				item_id: item.id,
				item_name: item.name,
				quantity: item.quantity,
				price: Number(item.price),
				item_category: item.category,
				item_category2: item.subcategory,
				item_brand: this.$store.state.menu.name,
				affiliation: this.$store.state.typeOrder,
			})),
		})

		if (this.typeOrder != TypeOrder.DELIVERY) {
			if (this.order) this.order.total = this.order.subtotal + this.order.deliveryCost
			const result = await OrderService.sendOrder(this.order, token, this.order.type)
			if (result) {
				this.$store.commit('setOrder', this.order)
			} else {
				this.ajaxError = true
			}
		} else {
			this.loading = false
			this.$router.push('/summary')
		}
		this.loading = false
	}

	validForm(): boolean {
		if (this.typeOrder == TypeOrder.LOCAL) {
			this.formErrors = { name: false, place: false }
			if (!this.formData.name) this.formErrors.name = true
			if (!this.formData.place) this.formErrors.place = true
			for (const error of Object.values(this.formErrors)) {
				if (error == true) return false
			}
		} else {
			this.formErrorDelivery = { name: false, phone: false, email: false, terms: false, phoneRepeat: false }
			if (!this.formData.name) this.formErrorDelivery.name = true
			if (!this.formData.phone || !/^[0-9]{10}$/.test(this.formData.phone)) this.formErrorDelivery.phone = true
			if (this.checkDigitRepeated(this.formData.phone, 5)) this.formErrorDelivery.phoneRepeat = true
			if (!this.formData.email || !/^\S+@.+\.\S+$/.test(this.formData.email)) this.formErrorDelivery.email = true
			if (!this.formData.terms) this.formErrorDelivery.terms = true
			for (const error of Object.values(this.formErrorDelivery)) {
				if (error == true) return false
			}
		}
		return true
	}

	checkDigitRepeated(input: string, repeat: number) {
		const regex = new RegExp('(\\d)\\1{' + repeat + '}', 'g')
		return !!input.match(regex)
	}

	hideForm() {
		this.modalForm = false
	}

	hideFormDelivery() {
		this.modalFormDelivery = false
	}

	reduceIngredients(ingredients: Array<ItemIngredient>, start: string) {
		let text = ''
		ingredients.forEach((ing, index) => {
			if (ing.selected) {
				const aux = start + ' ' + ing.localizedNames
				text += `${index == 0 ? aux : ', ' + aux}: `
				const lastIndexSelected =
					ing.extraIngredients.length -
					[...ing.extraIngredients].reverse().findIndex((ext) => ext.selected == true)
				ing.extraIngredients.forEach((extra, index) => {
					if (extra.selected) {
						text += `${index + 1 == lastIndexSelected ? extra.localizedNames : extra.localizedNames + ', '}`
					}
				})
			}
		})
		return text
	}

	updateItemQuantity(index: number, quantity: number) {
		this.$store.dispatch('updateItemQuantity', { index, quantity })
	}

	async created() {
		await this.$store.dispatch('setMainView', MainView.COMMAND)
		this.user = this.$store.state.user
		if (this.user) {
			this.formData.name = this.user.name
			this.formData.email = this.user.email
			this.formData.phone = this.user.phone
		}
		if (this.order) {
			this.$analytics.logEvent('view_cart', {
				value: this.order.subtotal + this.order.deliveryCost,
				currency: this.order.currency,
				items: this.order.items.map((item) => ({
					item_id: item.id,
					item_name: item.name,
					quantity: item.quantity,
					price: Number(item.price),
					item_category: item.category,
					item_category2: item.subcategory,
					item_brand: this.$store.state.menu.name,
					affiliation: this.$store.state.typeOrder,
				})),
			})
		}
	}

	get newUser() {
		return this.$store.state.user
	}

	@Watch('newUser')
	onNewUserChanged(newUser) {
		if (newUser) {
			this.formData.name = newUser.name
			this.formData.email = newUser.email
			this.formData.phone = newUser.phone
		}
	}

	checkDataUser(): boolean {
		const user = this.$store.state.user
		if (user) {
			for (const value in user) {
				if (user[value] == undefined || user[value] == '') {
					return false
				}
			}
		} else {
			return false
		}
		return true
	}
}
</script>

<style lang="scss" scoped>
.loader {
	position: fixed;
	z-index: 2000;
	background-color: rgba(0, 0, 0, 0.8);
}

.command {
	display: flex;
	flex-direction: column;
	justify-content: flex-start;
	background-color: white;
	color: black;
	width: 100%;
	height: 100%;
	overflow-y: auto;
	font-size: 1em;
	.info {
		padding: 0px 10px 0px 10px;
		font-style: normal;
		font-weight: bold;
		font-size: 24px;
		line-height: 28px;
	}

	.item {
		margin-bottom: 2.4em;
		display: flex;
		width: 90%;
		justify-content: space-between;
		font-size: 16px;
		font-weight: 700;
		display: flex;
		padding:1em;
		p {
			color: #feca38;
			font-size: 1.3em;
			margin: 0px;
		}
		.small-details {
			font-size: 14px;
			color: #757070;
			margin-top: 0.3em;
			margin-bottom: 0em;
		}
		.thumbnail {
			width: 62px;
			height: 62px;
			border-radius: 50%;
		}

		.item-info {
			display:flex;
			div{
				margin: 0 0.2em ;
			}
		}
		.number {
			margin-right: 15px;
		}
	}
	.send-container {
		width: 100%;
		display: flex;
		margin-top: auto;
		margin-bottom: 25px;
		position: fixed;
		bottom: 0;
		.send-button {
			margin: auto;
			width: 90%;
			height: 46px;
			text-align: end;
			span{
				color: #232323;
				float: left;
				margin-left: 8px;
				font-weight: 600;
				font-size: 18px;
				line-height: 27px;
			}
			p{
				font-size: 16px;
				line-height: 24px;
				margin: 0;
				text-align: right;
				margin-right: 8px;
			}
		}

		.disabled {
			visibility: hidden;
		}
	}

	.send-form {
		color: black;
		font-family: 'Roboto Condensed';

		.form-group {
			margin: 10px 0px;
		}
		.error {
			font-size: 12px;
			color: red;
			margin: auto;
		}
		.bee-input,
		.bee-button {
			width: 96%;
		}
		.bee-input {
			padding: 0 5px;
			font-size: 15px;
		}

		.noReembolsosDevoluciones {
			font-size: 10px;
			margin-top: 0.8em;
		}

		.terminos {
			font-size: 11px;
			display: inline-block;
			a {
				color: #0e2348;
			}
		}
	}

	.good-ending {
		color: black;
		display: flex;
		flex-direction: column;
		justify-content: flex-start;
		align-items: center;
		position: relative;
		.title {
			width: 100%;
			display: flex;
			justify-content: space-between;
			font-size: 30px;
			color: black;
			font-family: 'Roboto Condensed';
			font-weight: bolder;
		}

		.archive {
			position: absolute;
			bottom: -100px;
		}
	}
}
</style>
